unit ufrmCadPadrao;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ActnList, ExtCtrls, DBCtrls, DB, StdCtrls, Mask, DBClientActns,
  DBActns, ComCtrls, Buttons, Grids, DBGrids;

type
  TfrmCadastro = class(TForm)
    DataSource1: TDataSource;
    btnNovo: TBitBtn;
    btnExcluir: TBitBtn;
    btnGravar: TBitBtn;
    btnCancelar: TBitBtn;
    StatusBar1: TStatusBar;
    btnEditar: TBitBtn;
    procedure DataSource1StateChange(Sender: TObject);
    procedure btnNovoClick(Sender: TObject);
    procedure btnExcluirClick(Sender: TObject);
    procedure btnGravarClick(Sender: TObject);
    procedure btnCancelarClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnEditarClick(Sender: TObject);
  private
    { Private declarations }
  public
    procedure EnableDisableControls(Value: Boolean);
    function FieldsWrithe(DtSrc: TDataSource): Boolean;
  end;

var
  frmCadastro: TfrmCadastro;

implementation

{$R *.dfm}

function TfrmCadastro.FieldsWrithe(DtSrc: TDataSource): Boolean;
var
  i : integer;
//: verifica quais os campos que esto em branco no cadastro
begin
  inherited;
  Result := True; //: assume que esto todos preenchidos
  for i := 0 to DtSrc.DataSet.FieldCount - 1 do
    if DtSrc.DataSet.Fields[i].Required then
    BEGIN
      if (DtSrc.DataSet.Fields[i].IsNull)  Or (DtSrc.DataSet.Fields[i].AsString = '') then
      begin
        MessageDlg('Preencha o campo " '+ DtSrc.DataSet.Fields[i].DisplayLabel + '"', mtWarning,[mbOk], 0);
        Result := False;
        DtSrc.DataSet.Fields[i].FocusControl; //: coloca o foco no controle
        Break;
      end;
    end;
end;

procedure TfrmCadastro.DataSource1StateChange(Sender: TObject);
var
 x : boolean;
begin
  btnNovo.Enabled   := Not (DataSource1.State in [DSINSERT,DSEDIT]);
  btnEditar.Enabled   := Not (DataSource1.State in [DSINSERT,DSEDIT]);
  btnExcluir.Enabled   := Not (DataSource1.State in [DSINSERT,DSEDIT]);
  btnBusca.Enabled := Not (DataSource1.State in [DSINSERT,DSEDIT]);
//  BT_Fim.Enabled      := Not (DataSource1.State in [DSINSERT,DSEDIT]);
  btnGravar.Enabled    :=      DataSource1.State in [DSINSERT,DSEDIT];
  btnCancelar.Enabled  :=      DataSource1.State in [DSINSERT,DSEDIT];
  if not (DataSource1.State in [DSINSERT,DSEDIT]) then
    x := false;
  EnableDisableControls(x);
end;

procedure TfrmCadastro.btnNovoClick(Sender: TObject);
begin
  if not (datasource1.DataSet.State in [DSINSERT,DSEDIT]) then
    begin
      datasource1.DataSet.Insert;
      DataSource1.DataSet.Fields[1].FocusControl;
    end;
end;

procedure TfrmCadastro.btnExcluirClick(Sender: TObject);
begin
  if (DataSource1.DataSet.Active) and (DataSource1.DataSet.RecordCount > 0) then
  begin
    if MessageDlg('Tem certeza que deseja excluir o registro ?', mtConfirmation, [mbYes,mbNo], 0) = mrYes then
      DataSource1.DataSet.Delete;
  end;
end;

procedure TfrmCadastro.btnGravarClick(Sender: TObject);
begin
  {: salvo as dados se os campos estiverem preenchidos}
  if FieldsWrithe(DataSource1) and (DataSource1.State in [dsEdit, dsInsert]) then
  begin
    DataSource1.DataSet.Post;
    MessageDlg('O registro foi gravado com sucesso .', mtInformation, [mbOK], 0);
  end;
end;

procedure TfrmCadastro.btnCancelarClick(Sender: TObject);
begin
  if  (datasource1.DataSet.State in [DSINSERT,DSEDIT]) then
  datasource1.DataSet.Cancel;
end;

procedure TfrmCadastro.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if DataSource1.State in [dsEdit,dsInsert] then
  begin
    case MessageDlg('Deseja salvar as alteraes realizados no Cadastro ?', mtConfirmation, [mbYes,mbNo], 0) of
      mrYes:
      begin
        btnGravar.Click;
      end;
      mrNo:
      begin
        DataSource1.DataSet.Cancel;
        DataSource1.DataSet.Close;
        close;
      end;
    end;
    end
        else
          begin
            DataSource1.DataSet.Close;
          end;
end;

procedure TfrmCadastro.FormKeyPress(Sender: TObject; var Key: Char);
begin
  {: troca ENTER por TAB}
  if key = #13 then
  begin
    Perform (CM_DialogKey, VK_TAB, 0);
    key:=#0;
  end
end;

procedure TfrmCadastro.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  {: Esc para Sair}
  if key = VK_Escape then
    begin
      DataSource1.DataSet.Close;
      Close;
    end;
end;

procedure TfrmCadastro.EnableDisableControls(Value: Boolean);
var
  i : integer;
begin
  {: faz um lao em todos os componentes}
  for i := 0 to ComponentCount -1 do
  begin
    if (Components[i] is TDBEdit) then
       (Components[i] as TDBEdit).Enabled := Value;

    if (Components[i] is TDBComboBox) then
       (Components[i] as TDBComboBox).Enabled := Value;

    if (Components[i] is TDBLookupComboBox) then
       (Components[i] as TDBLookupComboBox).Enabled := Value;

    if (Components[i] is TDBMemo) then
       (Components[i] as TDBMemo).Enabled := Value;

  end;
end;

procedure TfrmCadastro.btnEditarClick(Sender: TObject);
begin
  DataSource1.DataSet.Edit;
  DataSource1.DataSet.Fields[1].FocusControl;
end;

end.
